'Imports System
'Imports System.Collections
'Imports System.Web
'Imports System.Web.UI
'Imports System.Web.UI.WebControls
'Imports System.Web.UI.HtmlControls
'Imports Microsoft.VisualBasic
'Imports System.Data
Imports System.Data.OleDb

Partial Public Class _Default
    Inherits System.Web.UI.Page

#Region " Cdigo generado por el Diseador de Web Forms "

    'El Diseador de Web Forms requiere esta llamada.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents Rejilla As System.Web.UI.WebControls.DataGrid
    Protected WithEvents Form2 As System.Web.UI.HtmlControls.HtmlForm
    Protected WithEvents LbAviso As System.Web.UI.WebControls.Label
    Protected WithEvents LbTotal As System.Web.UI.WebControls.Label

    'NOTA: el Diseador de Web Forms necesita la siguiente declaracin del marcador de posicin.
    'No se debe eliminar o mover.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: el Diseador de Web Forms requiere esta llamada de mtodo
        'No la modifique con el editor de cdigo.
        InitializeComponent()
    End Sub

#End Region

    'conexin de tipo OleDb a la base de datos
    Private conn As OleDbConnection = New OleDbConnection
    'objeto que rellena el DataSet con el origen de datos
    Private adaptador As OleDbDataAdapter
    'objeto que mantiene en memoria los datos
    Private datos As DataSet

    'Para construir la cadena de conexin a la BD
    'archivo MDB usa Microsoft.Jet.OLEDB.4.0 y archivo ACCDB usa Microsoft.ACE.OleDb.12.0
    'Private ruta As String = AppDomain.CurrentDomain.BaseDirectory + "500empresas.mdb"
    Private ruta As String = AppDomain.CurrentDomain.BaseDirectory + "500empresas.accdb"
    'Private proveedor As String = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source="
    Private proveedor As String = "Provider=Microsoft.ACE.OleDb.12.0;Data Source="

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Me.SmartNavigation = True 'est obsoleta, se cambia por MaintainScrollPositionOnPostBack
        'para no perder la posicin de la pgina web al reenviar los datos
        Me.Page.MaintainScrollPositionOnPostBack = True
        'cadena de conexin construida con 2 variables ya establecidas
        conn.ConnectionString = "" + proveedor + ruta + ""
        'OleDbDataAdapter con el comando SQL que coge todos los registros y los ordena por Telfono2
        adaptador = New OleDbDataAdapter("SELECT * FROM Contactos ORDER BY Nombre", conn)
        datos = New DataSet
        'el adaptador OleDbDataAdapter abre y cierra la conexin con el origen de los datos
        'conn.Open()
        'OleDbDataAdapter rellena el DataSet con la tabla seleccionada
        adaptador.Fill(datos, "Contactos")
        'comprobacin de los nombres de las tablas durante el desarrollo del ejercicio
        'ten en cuenta que la instruccin va en 3 lneas, para descomentarla hay que quitar ' en las 3 lneas
        'Response.Write("<div style='margin-left: auto; margin-right: auto; text-align: center;'>" _
        '& datos.Tables(0).Columns(0).ToString & " " & datos.Tables(0).Columns(1).ToString & " " _
        '& datos.Tables(0).Columns(2).ToString & "</div>")
        Rejilla.DataSource = datos.Tables(0)
        DataBind()
        'conn.Close()
        'mostrar el n total de registros del DataGrid contando todas las filas de la tabla
        'y el n de registros por pgina obtenido de la propiedad PageSize del DataGrid
        Dim n As Integer = datos.Tables("Contactos").Rows.Count
        Dim p As Integer = Rejilla.PageSize
        LbTotal.Text = "Nmero de registros en el DataGrid: <br/><b>" + "" + n.ToString + "</b><br/> Nmero de registros por pgina: <br/><b>" + "" + p.ToString + "</b>"
        LbAviso.Text = "Ruta actual a la base de datos: <br/><i>" + ruta + "</i>"
    End Sub

    'ordenar el DataGrid por Nombre
    Protected Sub BtNombre_Click(sender As Object, e As EventArgs) Handles BtNombre.Click
        'cadena de conexin construida con 2 variables ya establecidas
        conn.ConnectionString = "" + proveedor + ruta + ""
        'OleDbDataAdapter con el comando SQL que coge todos los registros y los ordena por Nombre
        adaptador = New OleDbDataAdapter("SELECT * FROM Contactos ORDER BY Nombre", conn)
        datos = New DataSet
        'el adaptador OleDbDataAdapter abre y cierra la conexin con el origen de los datos
        'conn.Open()
        adaptador.Fill(datos, "Contactos")
        Rejilla.DataSource = datos.Tables("Contactos")
        DataBind()
        'conn.Close()
    End Sub

    'ordenar el DataGrid por Telfono1
    Protected Sub BtId_Click(sender As Object, e As EventArgs) Handles BtTel1.Click
        'cadena de conexin construida con 2 variables ya establecidas
        conn.ConnectionString = "" + proveedor + ruta + ""
        'OleDbDataAdapter con el comando SQL que coge todos los registros y los ordena por Telfono1
        adaptador = New OleDbDataAdapter("SELECT * FROM Contactos ORDER BY Telfono1", conn)
        datos = New DataSet
        'el adaptador OleDbDataAdapter abre y cierra la conexin con el origen de los datos
        'conn.Open()
        adaptador.Fill(datos, "Contactos")
        Rejilla.DataSource = datos.Tables("Contactos")
        DataBind()
        'conn.Close()
    End Sub

    'ordenar el DataGrid por Telfono2
    Protected Sub BtTel_Click(sender As Object, e As EventArgs) Handles BtTel2.Click
        'cadena de conexin construida con 2 variables ya establecidas
        conn.ConnectionString = "" + proveedor + ruta + ""
        'OleDbDataAdapter con el comando SQL que coge todos los registros y los ordena por Telfono2
        adaptador = New OleDbDataAdapter("SELECT * FROM Contactos ORDER BY Telfono2", conn)
        datos = New DataSet
        'el adaptador OleDbDataAdapter abre y cierra la conexin con el origen de los datos
        'conn.Open()
        adaptador.Fill(datos, "Contactos")
        Rejilla.DataSource = datos.Tables("Contactos")
        DataBind()
        'conn.Close()
    End Sub

    'nos moveremos por las distintas pginas del DataGrid detectando su evento PageIndexChanged
    'modificando la propiedad CurrentPageIndex para establecer la pgina seleccionada por el usuario.
    Public Sub Rejilla_IndexChanged(ByVal obj As Object, ByVal e As DataGridPageChangedEventArgs)
        Rejilla.CurrentPageIndex = e.NewPageIndex
        Rejilla.DataBind()
    End Sub

    'Procedimiento que se produce al detectar el evento ItemCreated del DataGrid, se utiliza para cambiar por cdigo 
    'el texto de controles del DataGrid, en este caso el texto del control de paginacin para ir adelante o atrs
    'que por defecto muestra 3 puntos suspensivos y se cambia por las palabras Anterior y Siguiente que me gustan ms
    '
    'DirectCast se diferencia de CType en que CType se ejecuta bien si hay una conversin vlida 
    'pero DirectCast requiere que un tipo se herede del otro tipo o lo implemente
    '- la palabra clave DirectCast define una operacin de conversin de tipos y se utiliza de foma similar a la palabra clave CType
    '- las dos palabras clave toman como primer argumento una expresin para convertirla y como segundo argumento el tipo al que se va a convertir dicha expresin
    '- si no hay ninguna conversin definida entre el tipo de datos de la expresin y el tipo de datos especificado como segundo argumento, las dos conversiones fallan
    '
    Private Sub Rejilla_ItemCreated(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles Rejilla.ItemCreated
        If e.Item.ItemType = ListItemType.Pager Then
            For Each cont As System.Web.UI.WebControls.TableCell In e.Item.Controls
                For Each cont2 As System.Web.UI.Control In cont.Controls
                    If cont2.GetType.ToString = "System.Web.UI.WebControls.DataGridLinkButton" Then
                        If DirectCast(cont2, System.Web.UI.WebControls.LinkButton).Text = "..." Then
                            Dim pag As String = DirectCast(cont2, System.Web.UI.WebControls.LinkButton).CommandArgument
                            If Integer.Parse(pag) <= Rejilla.CurrentPageIndex Then
                                DirectCast(cont2, System.Web.UI.WebControls.LinkButton).Text = "Anterior"
                            Else
                                DirectCast(cont2, System.Web.UI.WebControls.LinkButton).Text = "Siguiente"
                            End If
                        End If
                    End If
                Next
            Next
        End If
    End Sub

End Class
